/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SISA                                                     */
/* Tabela : SINASAFRA                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 02/08/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_SISA
BEFORE INSERT OR UPDATE OR DELETE
ON SINASAFRA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUSISA := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.VRLIMINFSAFR,0) <> NVL(:NEW.VRLIMINFSAFR,0)) OR
         (NVL(:OLD.VRLIMSUPSAFR,0) <> NVL(:NEW.VRLIMSUPSAFR,0)) OR
         (NVL(:OLD.NMSINASAFRA,0)  <> NVL(:NEW.NMSINASAFRA,0))  OR
         (NVL(:OLD.NRCORSINSAFR,0) <> NVL(:NEW.NRCORSINSAFR,0)) THEN
         :NEW.DTULTATUSISA := SYSDATE;
      END IF;   
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('SINASAFRA', '', 'VRLIMINFSAFR='||TO_CHAR(:OLD.VRLIMINFSAFR,'000')||';VRLIMSUPSAFR='||TO_CHAR(:OLD.VRLIMSUPSAFR,'000')||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE SINASAFRA MODIFY DTULTATUSISA DEFAULT SYSDATE
/
