/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_DEPARTAMENTO                                             */
/* Tabela : DEPARTAMENTO                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_DEPARTAMENTO' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_DEPARTAMENTO
GO

CREATE TRIGGER DTULTATU_DEPARTAMENTO
ON DEPARTAMENTO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'DEPARTAMENTO', null, 'CDDEPTO=' + CDDEPTO + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE DEPARTAMENTO
      SET DTULTATUDEPT = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(DEPARTAMENTO.CDDEPTO,0)       = ISNULL(INSERTED.CDDEPTO,0)) AND
            (ISNULL(DEPARTAMENTO.CDFILIPEDORC,0)  = ISNULL(INSERTED.CDFILIPEDORC,0)) AND
            (ISNULL(DEPARTAMENTO.NMDEPTO,0)       = ISNULL(INSERTED.NMDEPTO,0));
   END;
END;
GO
