import {ChartViewInterface} from "@/Services/ChartView/ChartViewInterface";
import {ChartViewAbstract} from "@/Services/ChartView/ChartViewAbstract";
import { DialogService } from '@zeedhi/common';
import { ChartViewService } from "../ChartViewService";

export class Gauge extends ChartViewAbstract implements ChartViewInterface {
    public hasMultipleFacts: Boolean = false;

    public getWidget(dashboard: any, widget: any) {
        const height = widget[0].height;
        if (dashboard.label !== '' || dashboard.label !== null) {
            widget[0].options.title.text = dashboard.label;
        }
        widget[0].style = "background: " + dashboard.color + "; " + height;
        return widget;
    }

    public getCharts(charts: any) {
        if (charts[0].options.mask !== null && 'series' in charts[0].options) {
            charts[0].options.series[0].detail.formatter = ChartViewService.getMaskFunction(charts[0].mask);
            charts[0].options.series[0].axisLabel.formatter = ChartViewService.getMaskFunction(charts[0].mask);
        } else {
            DialogService.show({
                name: 'basic-dialog',
                text: 'All information will be lost. Do you want to cancel the operation?',
                buttons: undefined,
              });
        }
        return charts;
    }
}
